//----------------------------------------------------------------------------------
//		Aj̗֊stB^
//----------------------------------------------------------------------------------
#include <windows.h>
#include <omp.h>
#include <vector>

#include "filter.h"




//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
#define	TRACK_N	5														//	gbNo[̐
TCHAR	*track_name[] =		{	"x臒l",	"F臒l",	"臒l",	"Gain",	"Gain",	"Offset"	};	//	gbNo[̖O
int		track_default[] =	{	160,		60,			10,			64,		128,		0,					};	//	gbNo[̏l
int		track_s[] =			{	0,			0,			0,			0,			0,			-128,			};	//	gbNo[̉l
int		track_e[] =			{	255,		128,		64,			256,		256,		127,	};	//	gbNo[̏l

#define	CHECK_N	1
//	`FbN{bNX̐
TCHAR	*check_name[] = 	{	"[h"	};				//	`FbN{bNX̖O
int		check_default[] = 	{	0			};					//	`FbN{bNX̏l (l01)

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION,	//	tB^̃tO
								//	FILTER_FLAG_ALWAYS_ACTIVE		: tB^ɃANeBuɂ܂
								//	FILTER_FLAG_CONFIG_POPUP		: ݒ|bvAbvj[ɂ܂
								//	FILTER_FLAG_CONFIG_CHECK		: ݒ`FbN{bNXj[ɂ܂
								//	FILTER_FLAG_CONFIG_RADIO		: ݒWI{^j[ɂ܂
								//	FILTER_FLAG_EX_DATA				: gf[^ۑo悤ɂ܂B
								//	FILTER_FLAG_PRIORITY_HIGHEST	: tB^̃vCIeBɍŏʂɂ܂
								//	FILTER_FLAG_PRIORITY_LOWEST		: tB^̃vCIeBɍŉʂɂ܂
								//	FILTER_FLAG_WINDOW_THICKFRAME	: TCYύX\ȃEBhE܂
								//	FILTER_FLAG_WINDOW_SIZE			: ݒEBhẼTCYwo悤ɂ܂
								//	FILTER_FLAG_DISP_FILTER			: \tB^ɂ܂
								//	FILTER_FLAG_EX_INFORMATION		: tB^̊gݒł悤ɂ܂
								//	FILTER_FLAG_NO_CONFIG			: ݒEBhE\Ȃ悤ɂ܂
								//	FILTER_FLAG_AUDIO_FILTER		: I[fBItB^ɂ܂
								//	FILTER_FLAG_RADIO_BUTTON		: `FbN{bNXWI{^ɂ܂
								//	FILTER_FLAG_WINDOW_HSCROLL		: XN[o[EBhE܂
								//	FILTER_FLAG_WINDOW_VSCROLL		: XN[o[EBhE܂
								//	FILTER_FLAG_IMPORT				: C|[gj[܂
								//	FILTER_FLAG_EXPORT				: GNX|[gj[܂
	0,0,						//	ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
	"LineSharp",			//	tB^̖O
	TRACK_N,					//	gbNo[̐ (0Ȃ疼OlNULLł悢)
	track_name,					//	gbNo[̖OSւ̃|C^
	track_default,				//	gbNo[̏lSւ̃|C^
	track_s,track_e,			//	gbNo[̐l̉ (NULLȂS0`256)
	CHECK_N,					//	`FbN{bNX̐ (0Ȃ疼OlNULLł悢)
	check_name,					//	`FbN{bNX̖OSւ̃|C^
	check_default,				//	`FbN{bNX̏lSւ̃|C^
	func_proc,					//	tB^֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,NULL,					//	VXeŎg܂̂ŎgpȂł
	NULL,						//  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	NULL,						//  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
	"LineSharptB^ version 0.01",
								//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
	NULL,						//	Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
	NULL,						//	Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};


//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}




inline int sign( int a , int threshold )
{
	if( a < -threshold ) return -1;
	if( a > threshold ) return 1;
	return 0;
}



void mask_expand( std::vector< std::vector< char > > &mask )
{
	std::vector< std::vector< char > > tmp( mask );

	const int y_size = static_cast<int>(mask.size()-1);
	const int x_size = static_cast<int>(mask[0].size()-1);
	for(int y = 1 ; y < y_size ; ++y )
	{

		#pragma omp parallel for
		for( int x = 1 ; x < x_size ; ++x )
		{
			if( ( tmp[y-1][x-1] + tmp[y-1][x] + tmp[y-1][x+1] + tmp[y][x-1] + tmp[y][x] + tmp[y][x+1] + tmp[y+1][x-1] + tmp[y+1][x] + tmp[y+1][x+1] )>1  )
			{
				mask[y-1][x-1] = mask[y-1][x] = mask[y-1][x+1]= 
				mask[y][x-1] = mask[y][x] = mask[y][x+1] =1;
				//mask[y+1][x-1] = mask[y+1][x] = mask[y+1][x+1] = 1;
			}
			else
			{				
				mask[y-1][x-1] = mask[y-1][x] = mask[y-1][x+1]= 
				mask[y][x-1] = mask[y][x] = mask[y][x+1] =0;
				//mask[y+1][x-1] = mask[y+1][x] = mask[y+1][x+1] = 0;
			}
		}
	}

}

//---------------------------------------------------------------------
//		tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
//
//	fp->track[n]			: gbNo[̐l
//	fp->check[n]			: `FbN{bNX̐l
//	fpip->w 				: ۂ̉摜̉
//	fpip->h 				: ۂ̉摜̏c
//	fpip->max_w				: 摜̈̉
//	fpip->max_h				: 摜̈̏c
//	fpip->ycp_edit			: 摜̈ւ̃|C^
//	fpip->ycp_temp			: e|̈ւ̃|C^
//	fpip->ycp_edit[n].y		: f(Px    )f[^ (     0 ` 4096 )
//	fpip->ycp_edit[n].cb	: f(F())f[^ ( -2048 ` 2048 )
//	fpip->ycp_edit[n].cr	: f(F())f[^ ( -2048 ` 2048 )
//
//  ff[^͔͈͊OɏoĂ邱Ƃ܂B
//  ܂͈͓Ɏ߂ȂĂ܂܂B
//
//	摜TCYςƂ fpip->w  fpip->h ς܂B
//
//	e|̈ɏ摜i[Ƃ
//	fpip->ycp_edit  fpip->ycp_temp ւ܂B
//
	const int luma_threshold = max( 0, min( fp->track[0] * 16 , 256*16));
	const int crcb_threshold = max( 0, min( fp->track[1] * 16 , 128*16));
	const int threshold = max( 0, min( fp->track[2] * 16 , 128*16));
	const int light_gain = max(0, min(256, fp->track[3]) );
	const int dark_gain = max(0, min(256, fp->track[4]) );
	const int offset = max(-128, min(128,fp->track[5]) );

	const bool is_test = fp->check[0] != 0;

	int width = fpip->w;
	int height = fpip->h;

	std::vector< std::vector< char > > mask( height, std::vector< char >( width ) );
	//#pragma omp parallel 
	{
	

		for (int y = 1 ; y < height-1 ; ++y )
		{
/*
			PIXEL_YC *pp,*pc,*pn;
			PIXEL_YC *p , *c, *n;
			PIXEL_YC *np,*nc,*nn;

			p = fpip->ycp_edit + y * fpip->max_w;
			c= p+1;
			n = c+1;
			pp = p - fpip->max_w;
			pc = c - fpip->max_w;
			pn = n - fpip->max_w;
			np = p + fpip->max_w;
			nc = c + fpip->max_w;
			nn = n + fpip->max_w;
			PIXEL_YC *dst = fpip->ycp_temp + y * fpip->max_w +1;
*/
			#pragma omp parallel for
			for (int x = 1 ; x < width-1 ; ++x )
			{
				PIXEL_YC *p , *c, *n;

				p = fpip->ycp_edit + y * fpip->max_w +x -1;
				c= p+1;
				n = c+1;
				
				bool acu_y( c->y < luma_threshold );
				bool acu_cr( sign( c->cr, crcb_threshold ) == 0 );
				bool acu_cb( sign( c->cb, crcb_threshold ) == 0 );
				if (acu_y  && ( acu_cr || acu_cb ) )
				{
					PIXEL_YC *pp,*pc,*pn;
					PIXEL_YC *np,*nc,*nn;
					pp = p - fpip->max_w;
					pc = pp +1;
					pn = pc +1;
					np = p + fpip->max_w;
					nc = np + 1;
					nn = nc + 1;
					PIXEL_YC *dst = fpip->ycp_temp + y * fpip->max_w +x;
					const int bump_threshold = threshold;
					int up = sign( c->y - pp->y ,bump_threshold );//Ƃ̍
					int uc = sign( c->y - pc->y ,bump_threshold);//
					int un = sign( c->y - pn->y ,bump_threshold);//E

					int cp = sign( c->y - p->y ,bump_threshold);
					int cn = sign( c->y - n->y ,bump_threshold);

					int dp = sign( c->y - np->y ,bump_threshold );//Ƃ̍
					int dc = sign( c->y - nc->y ,bump_threshold );//
					int dn = sign( c->y - nn->y ,bump_threshold );//E

					bool backslash = (up < 0) && (dn < 0);
					bool virtical = uc< 0 && dc < 0;
					bool slash = un < 0 && dp < 0;
					bool holizonal = cp < 0 && cn < 0;
		

					if( backslash || virtical || slash || holizonal )
					{
						mask[y][x] = 1;
					}
				}
/*				pp = pc;
				pc = pn;
				++pn;

				p = c;
				c = n;
				++n;

				np = nc;
				nc = nn;
				++nn;
				++dst;
*/
			}
		}
#pragma omp barrier
		mask_expand( mask );

		if ( is_test )
		{
			for (int y = 0 ; y < height ; ++y )
			{
				PIXEL_YC *c = fpip->ycp_edit + y * fpip->max_w ;
				PIXEL_YC *dst = fpip->ycp_temp + y *fpip->max_w ;
				for (int x = 0 ; x < width ; ++x )
				{
					if( mask[y][x] )
					{
						dst->y =200 * 16;
						dst->cb = 200*16;
						dst->cr = 200*16;
					}
					else
					{
						*dst = *c;
					}
					++dst;
					++c;
				}
			}
		
		
		}
		else
		{

			for (int y = 0 ; y < height ; ++y )
			{
				#pragma omp parallel for
				for (int x = 0 ; x < width ; ++x )
				{
					PIXEL_YC *c = fpip->ycp_edit + y * fpip->max_w+x;
					PIXEL_YC *dst = fpip->ycp_temp + y *fpip->max_w+x;
					*dst = *c;
					if( mask[y][x] )
					{
					
						int n_ave = 0;
						for(int iy =-2; iy < 3 ; ++iy)
						{
							int ady = y + iy;
							if( ady < 0 )
							{
								ady = - ady; 
							}
							else if( ady > height )
							{
								ady = 2*height - ady; 
							}
							ady *= fpip->max_w;
							for( int ix = -2; ix < 3; ++ix)
							{
								int adx = x + ix;
								if( adx < 0 )
								{
									adx = - adx; 
								}
								else if( adx > width )
								{
									adx = 2*width - adx; 
								}
								PIXEL_YC* src = fpip->ycp_edit + ady + adx;
								n_ave += src->y;
							}
						}
						n_ave /= 25;
						int luma = c->y;
						luma += offset*16;
						int d = (n_ave - c->y);
						if ( d < 0 )
						{
							luma -= ( d * light_gain / 128 );
						}
						else
						{
							luma -= ( d * dark_gain / 128 );
						}
						if (luma < 0 ) luma =0;
						if (luma > 4096 )
						{
							luma =4096;
							dst->cb = 0;
							dst->cr = 0;
						}
						dst->y =luma;
					}
				}
			}

		}
#pragma omp barrier
		PIXEL_YC *tmp  = fpip->ycp_edit;
		fpip->ycp_edit = fpip->ycp_temp;
		fpip->ycp_temp = tmp;
	
  }

	return TRUE;
}


